#ifndef cnoise_H
#define cnoise_H

#include "c3d.h"

//---------------------------------------------------------------------------------------
class CNoise
{

private:

   int mSelectMode;

   // Add vertices to undo recursively in groups
   static void AddGroupUndoPos( List **vlist, List *olist );
   // Add vertices to undo recursively in groups
   static void AddGroupUndoTex( List **slist, List *olist );

   // Move objects' vertices recursively in groups
   static void MoveGroupVertices( ACObject *o, Vertex &delta );

   // Scale objects' vertices recursively in groups
   static void ScaleGroupVertices( ACObject *o, Point3 *center, Point3 *size, Vertex &delta );

   // Rotate objects' vertices recursively in groups
   static void RotateGroupVertices( ACObject *o, Point3 *center, Vertex &delta );

   // Adjust objects' tex coord vertices recursively in groups
   static void TexCoordGroupVertices( ACObject *o, Point2 &delta );

public:

   CNoise();
   ~CNoise();

   // Add affected vertices to Undo
   void AddUndoVertPos();
   // Add affected surfaces to Undo
   void AddUndoSurfTex();

   // Perform a random move
   void Move( Vertex &opvec );
   // Perform a random scale
   void Scale( Vertex &opvec );
   // Perform a random rotation
   void Rotate( Vertex &opvec );
   // Perform a random texture coordinate offset
   void TexCoord( Vertex &opvec );

};
//---------------------------------------------------------------------------------------

#endif