proc ddhnoise_spinbox { framename labeltext bmin bmax binc var sbwidth balloon } {

   frame $framename
   pack $framename -side top -fill x

   label $framename.lbl -text $labeltext
   pack $framename.lbl -side left -fill x

   spinbox $framename.sbx -from $bmin -increment $binc -to $bmax -textvariable $var -width $sbwidth
   pack $framename.sbx -side right -fill x

   add_balloon $framename.lbl $balloon

}

proc ddhnoise_makeframe {} {

   toplevel .ddhnoise
   wm title .ddhnoise "Noise"
   wm transient .ddhnoise [winfo toplevel [winfo parent .ddhnoise]]

   set width 6
   set ypad 3

   ###########################################################################
   # Move

   ddhnoise_spinbox .ddhnoise.frmmovex "Move X" 0 1000 0.01 ddhnoise_movex $width "Units to randomly move along the X axis"
   ddhnoise_spinbox .ddhnoise.frmmovey "Move Y" 0 1000 0.01 ddhnoise_movey $width "Units to randomly move along the Y axis"
   ddhnoise_spinbox .ddhnoise.frmmovez "Move Z" 0 1000 0.01 ddhnoise_movez $width "Units to randomly move along the Z axis"

   frame .ddhnoise.frmmove
   pack .ddhnoise.frmmove -side top -fill x

   button .ddhnoise.frmmove.btnapply -text "Move" -command {
      eval ac3d ddhnoise_go $ddhnoise_movex $ddhnoise_movey $ddhnoise_movez 0
   }
   pack .ddhnoise.frmmove.btnapply -side left -fill x -expand 1

   ###########################################################################
   # Scale

   #ddhnoise_spinbox .ddhnoise.frmscax "Scale X" 0 360 1 ddhnoise_scax $width "Units to randomly scale along the X axis"
   #ddhnoise_spinbox .ddhnoise.frmscay "Scale Y" 0 360 1 ddhnoise_scay $width "Units to randomly scale along the Y axis"
   #ddhnoise_spinbox .ddhnoise.frmscaz "Scale Z" 0 360 1 ddhnoise_scaz $width "Units to randomly scale along the Z axis"

   #frame .ddhnoise.frmsca
   #pack .ddhnoise.frmsca -side top -fill x

   #button .ddhnoise.frmsca.btnapply -text "Scale objects" -command {
      #eval ac3d ddhnoise_go $ddhnoise_scax $ddhnoise_scay $ddhnoise_scaz 2
   #}
   #pack .ddhnoise.frmsca.btnapply -side left -fill x -expand 1

   ###########################################################################
   # Rotate

   ddhnoise_spinbox .ddhnoise.frmrotx "Rotate X" 0 360 1 ddhnoise_rotx $width "Degrees to randomly rotate around the X axis"
   ddhnoise_spinbox .ddhnoise.frmroty "Rotate Y" 0 360 1 ddhnoise_roty $width "Degrees to randomly rotate around the Y axis"
   ddhnoise_spinbox .ddhnoise.frmrotz "Rotate Z" 0 360 1 ddhnoise_rotz $width "Degrees to randomly rotate around the Z axis"

   frame .ddhnoise.frmrot
   pack .ddhnoise.frmrot -side top -fill x

   button .ddhnoise.frmrot.btnapply -text "Rotate about objects" -command {
      eval ac3d ddhnoise_go $ddhnoise_rotx $ddhnoise_roty $ddhnoise_rotz 1
   }
   pack .ddhnoise.frmrot.btnapply -side left -fill x -expand 1

   ###########################################################################
   # Texture coordinates

   ddhnoise_spinbox .ddhnoise.frmtexx "Tex offset X %" 0 100 100 ddhnoise_texx $width "Percentage to randomize the X texture coordinate"
   ddhnoise_spinbox .ddhnoise.frmtexy "Tex offset Y %" 0 100 100 ddhnoise_texy $width "Percentage to randomize the Y texture coordinate"

   frame .ddhnoise.frmtex
   pack .ddhnoise.frmtex -side top -fill x

   button .ddhnoise.frmtex.btnapply -text "Adjust texture offset" -command {
      eval ac3d ddhnoise_go $ddhnoise_texx $ddhnoise_texy $ddhnoise_movez 3
   }
   pack .ddhnoise.frmtex.btnapply -side left -fill x -expand 1

}

proc ddhnoise_dialog {} {

   global ddhnoise_movex
   global ddhnoise_movey
   global ddhnoise_movez
   global ddhnoise_scax
   global ddhnoise_scay
   global ddhnoise_scaz
   global ddhnoise_rotx
   global ddhnoise_roty
   global ddhnoise_rotz
   global ddhnoise_texx
   global ddhnoise_texy

   if ![winfo exists .ddhnoise] {
      set ddhnoise_movex 0.00
      set ddhnoise_movey 0.00
      set ddhnoise_movez 0.00
      set ddhnoise_scax 0.00
      set ddhnoise_scay 0.00
      set ddhnoise_scaz 0.00
      set ddhnoise_rotx 0
      set ddhnoise_roty 0
      set ddhnoise_rotz 0
      set ddhnoise_texx 100
      set ddhnoise_texy 100
      ddhnoise_makeframe
   }

   wm deiconify .ddhnoise
   centre_window_on_screen .ddhnoise

}

